#ifndef PlayState_H
#define PlayState_H

#include <OGRE/Ogre.h>

#include "GameState.h"

class PlayState : public GameState
{
public:
	void enter();
	void exit();

	void pause();
	void resume();

	void keyClicked(Ogre::KeyEvent* e);
	void keyPressed(Ogre::KeyEvent* e);
	void keyReleased(Ogre::KeyEvent* e);
	bool frameStarted(const Ogre::FrameEvent& evt);
	bool frameEnded(const Ogre::FrameEvent& evt);

	static PlayState* getInstance() { return &mPlayState; }

	

protected:
	PlayState() { }

	Ogre::Root *mRoot;
	Ogre::SceneManager* mSceneMgr;
	Ogre::Viewport* mViewport;
	Ogre::InputReader* mInputDevice;
	Ogre::Camera* mCamera;
	//Ogre::AnimationState *mAnimationState;
 	Ogre::SceneNode *mNode;
	Ogre::Entity *mEntity;
	Ogre::RaySceneQuery *mRaySceneQueryCam;
	//Ogre::RaySceneQuery *mRaySceneQueryRobot;
	Ogre::Vector3 camPos;
	//Ogre::Vector3 robotPos;
	Ogre::StaticGeometry* StatGeom;
	Ogre::Sphere CameraSphere;
	Ogre::Sphere TestSphere;
	Ogre::AxisAlignedBox TestAABox;
	Ogre::AxisAlignedBox TestbuildingAABox;
	Ogre::ParticleSystem* TestParticle;
	Ogre::Overlay* testoverlay;

private:
	static PlayState mPlayState;
	void PlaySetScene0 ();
	void PlayMove(const Ogre::FrameEvent& evt);
};

#endif
