#include "../include/PlayState.h"

using namespace Ogre;

void PlayState::PlaySetScene0()
{
	mSceneMgr->setShadowTechnique(SHADOWTYPE_STENCIL_MODULATIVE);
	//mSceneMgr->setAmbientLight( ColourValue( 0.2,0.2,0.2 ));
	Light* testlight = mSceneMgr->createLight ("testlight");
	testlight->setType(Light::LT_POINT);
	testlight->setPosition (2000, 500, 2000);
	testlight->setDiffuseColour (1.0, 0.0, 0.0);
	     
	StatGeom= mSceneMgr->createStaticGeometry("StatGeom");

 	mSceneMgr->setSkyDome(true, "Skydome/test", 6, 0);

       // World geometry
        mViewport->setBackgroundColour(ColourValue(0.1, 0.1, 0.1));		
	//mSceneMgr->setFog( FOG_EXP,ColourValue(0.1,0.1,0.1), 0.005);

	mSceneMgr->setWorldGeometry( "terrain.cfg" );

	mEntity = mSceneMgr->createEntity( "Holzwand0", "holzwand0.mesh" );

        // Create the scene node
        mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "Holzwand0Node", Vector3( 500.0f, 600.0f,20.0f ) );
	
        mNode->attachObject( mEntity );
	mNode->	setScale (100.0f, 30.0f, 100.0f);
	StatGeom->addSceneNode(mNode);
	
	mEntity = mSceneMgr->createEntity( "Test", "test.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "testNode", Vector3( 2000.0f, 150.0f,2000.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (100.0f, 30.0f, 100.0f);
	mNode->pitch (Degree(90));
	StatGeom->addSceneNode(mNode);

	mEntity = mSceneMgr->createEntity( "Steinhaus0", "steinhaus0.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "Steinhaus0Node", Vector3( 3000.0f, 60.0f,3000.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (50.0f, 50.0f, 50.0f);
	mNode->pitch (Degree(90));
	StatGeom->addSceneNode(mNode);
	
	mEntity = mSceneMgr->createEntity( "Cube", "Cube.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "CubeNode", Vector3( 6000.0f, 60.0f,6000.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (70.0f, 70.0f, 70.0f);
	StatGeom->addSceneNode(mNode);

	mEntity = mSceneMgr->createEntity( "Water", "testwater.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "WaterNode", Vector3( 6000.0f, 3.0f,6000.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (70.0f, 70.0f, 70.0f);
	StatGeom->addSceneNode(mNode);

	mEntity = mSceneMgr->createEntity( "Eye", "testeye.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "EyeNode", Vector3( 2500.0f, 200.0f,2500.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (70.0f, 70.0f, 70.0f);
	StatGeom->addSceneNode(mNode);

	mEntity = mSceneMgr->createEntity( "Building", "testbuilding.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "BuildingNode", Vector3( 2000.0f, 1400.0f,5000.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (1500.0f, 1500.0f, 1500.0f);
	StatGeom->addSceneNode(mNode);

	mEntity = mSceneMgr->createEntity( "stoneblock0", "stoneblock0.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "stoneblock0Node", Vector3( 5700.0f, 10.0f,4600.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (150.0f, 150.0f, 150.0f);
	StatGeom->addSceneNode(mNode);

	mEntity = mSceneMgr->createEntity( "tree0", "tree0.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "tree0Node", Vector3( 4300.0f, 10.0f,900.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (150.0f, 150.0f, 150.0f);
	StatGeom->addSceneNode(mNode);

	mEntity = mSceneMgr->createEntity( "testanim", "testanim.mesh" );
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "testanimNode", Vector3( 2700.0f, 10.0f,900.0f ) );
	mNode->attachObject( mEntity );
	mNode->	setScale (150.0f, 150.0f, 150.0f);
	StatGeom->addSceneNode(mNode);
	
	//animation
	//mAnimationState = mEntity->getAnimationState( "testanim" );
        //mAnimationState->setLoop( true );
        //mAnimationState->setEnabled( true );

	this->TestSphere.setCenter(Vector3(6000.0f, 60.0f,6000.0f));
	this->TestSphere.setRadius(100.0f);

	this->TestAABox.setMinimum (600.0f, 0.0f, 600.0f);
	this->TestAABox.setMaximum (7500.0f, 500.0f, 7500.0f);

	this->TestbuildingAABox.setMinimum (500.0f, 0.0f, 3500.0f);
	this->TestbuildingAABox.setMaximum (3500.0f, 500.0f, 6500.0f);
	
	this->CameraSphere.setRadius(100.0f);
	
        this->TestParticle = ParticleSystemManager::getSingleton().createSystem("Test","Test");
	mNode = mSceneMgr->getRootSceneNode( )->createChildSceneNode( "ParticleNode", Vector3( 6000.0f, 200.0f,6000.0f ) );
 	mNode->attachObject(TestParticle);
 	StatGeom->addSceneNode(mNode);

	this->testoverlay = OverlayManager::getSingleton().getByName ("Testoverlay");
	this->testoverlay->show();
}
